1.Acwing 1210. 连号区间数
小明这些天一直在思考这样一个奇怪而有趣的问题:
在 1∼N的某个排列中有多少个连号区间呢?
这里所说的连号区间的定义是:
如果区间 [L,R]里的所有元素(即此排列的第 L 个到第 R个元素)递增排序后能得到一个长度为 R−L+1 的“连续”数列,则称这个区间连号区间。
当 NN很小的时候,小明可以很快地算出答案,但是当 N 变大的时候,问题就不是那么简单了,现在小明需要你的帮助。
输入格式
第一行是一个正整数 N,表示排列的规模。
第二行是 N个不同的数字 Pi,表示这 N个数字的某一排列。
输出格式
输出一个整数,表示不同连号区间的数目。
数据范围
1≤N≤10000
1≤Pi≤N
输入样例1:
4
3 2 4 1
输出样例1:
7
输入样例2:
5
3 4 2 5 1
输出样例2:
9
//题目中排列暗示数组无重复
//将数列依次+1递增转化为满足最大值-最小值等于下标之差
#include
#include
#include
#include
using namespace std;
const int N=10001,INF=1000000;
int a[N],n;
int main()
{
int count=0;
cin>>n;
for(int i=0;i<n;i++) cin>>a[i];
for(int i=0;i<n;i++) //枚举左端点
{
int Max=-INF,Min=INF;
for(int j=i;j<n;j++) //枚举右端点
{
Max=max(Max,a[j]);
Min=min(Min,a[j]);
if(Max-Min==j-i) //满足最大值-最小值等于下标之差的,符合要求
count++;
}
}
cout<<count;
getchar();getchar();
return 0;
}
2.Acwing 1236. 递增三元组
https://www.acwing.com/problem/content/1238/
法1:前缀和
//前缀和做法
#include
#include
#include
using namespace std;
typedef long long LL;
const int N=100010;
int a[N],b[N],c[N],n;
int cnt[N]; //cnt[i]表示i出现的次数
int s[N]; //前缀和数组,s[i]表示1 ~ i总共出现的次数
int as[N],cs[N]; //分别表示小于b[i],大于b[i]的个数
int main()
{
cin>>n;
for(int i=0;i<n;i++) scanf("%d",&a[i]);
for(int i=0;i<n;i++) scanf("%d",&b[i]);
for(int i=0;i<n;i++) scanf("%d",&c[i]);
for(int i=0;i<n;i++) cnt[a[i]]++;
for(int i=0;i<N;i++) s[i]=s[i-1]+cnt[i];
for(int i=0;i<n;i++) as[i]=s[b[i]-1]; //小于b[i]的个数
memset(cnt,0,sizeof(cnt)); //用过了cnt,别忘了清0
for(int i=0;i<n;i++) cnt[c[i]]++;
for(int i=0;i<N;i++) s[i]=s[i-1]+cnt[i];
for(int i=0;i<n;i++) cs[i]=s[N-1]-s[b[i]]; //大于b[i]的个数
LL res=0; //由于数据范围可能会爆int,所以用long long
for(int i=0;i<n;i++) res=res+(LL)as[i]*cs[i];
getchar();getchar();
return 0;
}
法二:sort+二分
二分STL用法:https://blog.csdn.net/qq_40160605/article/details/80150252
//sort+二分查找做法(使用STL实现二分)
#include
#include
#include
#include
using namespace std;
typedef long long lld;
const int N = 100005;
int a[N], b[N], c[N];
int n;
lld sum;
int main()
{
scanf("%d", &n);
for (int i = 1; i <= n; i++)
scanf("%d", &a[i]);
for (int i = 1; i <= n; i++)
scanf("%d", &b[i]);
for (int i = 1; i <= n; i++)
scanf("%d", &c[i]);
//由于二分的前提是单调序列 所以预先对a b c排序 直接sort
sort(a + 1, a + 1 + n);
sort(b + 1, b + 1 + n);
sort(c + 1, c + 1 + n);
for (int i = 1; i <= n; i++) //对b数组中一个一个b[i]去二分查找比b[i]大的与比b[i]小的
{
//直接用STL中的两个二分函数解决
lld x = (lower_bound(a + 1, a + 1 + n, b[i]) - a) - 1; //在数组a中找比b[i]小的数
lld y = n - (upper_bound(c + 1, c + 1 + n, b[i]) - c) + 1; //在数组c中找比b[i]大的数
sum += x * y;
}
printf("%lld", sum);
getchar();getchar();
return 0;
}
3.Acwing 1245
小明对数位中含有 2、0、1、9的数字很感兴趣(不包括前导 00),在 1到 40 中这样的数包括 1、2、9、10 至 32、39 和 40,共 28 个,他们的和是 574。
请问,在 11 到 nn 中,所有这样的数的和是多少?
输入格式
共一行,包含一个整数 n。
输出格式
共一行,包含一个整数,表示满足条件的数的和。
数据范围
1≤n≤10000
输入样例:
40
输出样例:
574
#include
#include
using namespace std;
int n,s,t;
int main()
{
cin>>n;
for(int i=1;i<=n;i++)
{
int x=i;
while(x!=0)
{
t=x%10;
x=x/10; //把每一位取出来判断
if(t==2||t==1||t==0||t==9)
{
s=s+i;
break;
}
}
}
cout<<s;
getchar();getchar();
return 0;
}
4.Acwing 1204
某涉密单位下发了某种票据,并要在年终全部收回。
每张票据有唯一的ID号。
全年所有票据的ID号是连续的,但ID的开始数码是随机选定的。
因为工作人员疏忽,在录入ID号的时候发生了一处错误,造成了某个ID断号,另外一个ID重号。
你的任务是通过编程,找出断号的ID和重号的ID。
假设断号不可能发生在最大和最小号。
输入格式
第一行包含整数 N,表示后面共有 N 行数据。
接下来 N 行,每行包含空格分开的若干个(不大于100个)正整数(不大于100000),每个整数代表一个ID号。
输出格式
要求程序输出1行,含两个整数 m,n用空格分隔。
其中,m表示断号ID,n表示重号ID。
数据范围
1≤N≤100
输入样例:
2
5 6 8 11 9
10 12 9
输出样例:
7 9
#include
#include
#include
#include
#include
using namespace std;
const int N=10010;
int n,cnt;
int a[N];
int main()
{
cin>>n;
string line; //getline用于读取一行数据,可以读空格,遇到换行符或EOF结束
getline(cin,line); //读取掉第一行的回车
while(n--)
{
getline(cin,line); //读取结果放在line中
stringstream ssin(line);
while(ssin>>a[cnt]) cnt++; //从line中读取,每次读取放在a[]中
}
sort(a,a+cnt);
int res1=0,res2=0;
for(int i=1;i<cnt;i++)
{
if(a[i]==a[i-1]) res2=a[i];
else if(a[i]>=a[i-1]+2) res1=a[i]-1;
}
cout<<res1<<" "<<res2<<endl;
getchar();getchar();
return 0;
}
5.Acwing 466 回文日期
在日常生活中,通过年、月、日这三个要素可以表示出一个唯一确定的日期。
牛牛习惯用 8 位数字表示一个日期,其中,前 4 位代表年份,接下来 2 位代表月份,最后 2 位代表日期。
显然:一个日期只有一种表示方法,而两个不同的日期的表示方法不会相同。
牛牛认为,一个日期是回文的,当且仅当表示这个日期的8位数字是回文的。
现在,牛牛想知道:在他指定的两个日期之间(包含这两个日期本身),有多少个真实存在的日期是回文的。
一个 8 位数字是回文的,当且仅当对于所有的 i(1≤i≤8) 从左向右数的第i个数字和第 9−i 个数字(即从右向左数的第 i 个数字)是相同的。
例如:
•对于2016年11月19日,用 8 位数字 20161119 表示,它不是回文的。
•对于2010年1月2日,用 8 位数字 20100102 表示,它是回文的。
•对于2010年10月2日,用 8 位数字 20101002 表示,它不是回文的。
输入格式
输入包括两行,每行包括一个8位数字。
第一行表示牛牛指定的起始日期date1,第二行表示牛牛指定的终止日期date2。保证date1和date2都是真实存在的日期,且年份部分一定为4位数字,且首位数字不为0。
保证date1一定不晚于date2。
输出格式
输出共一行,包含一个整数,表示在date1和date2之间,有多少个日期是回文的。
输入样例:
20110101
20111231
输出样例:
1
#include
#include
#include
#include
using namespace std;
int a,b,ans,res;
int d[13] = {
0,31,29,31,30,31,30,31,31,30,31,30,31};//每个月的天数
int main()
{
scanf("%d %d",&a,&b);
for(int i=1;i<=12;i++)
{
for(int j=1;j<=d[i];j++)
{
//一位位的处理,最终枚举出回文数
ans=j%10*10000000+j/10*1000000+i%10*100000+i/10*10000+i/10*1000+i%10*100+j/10*10+j%10;
if(ans<=b&&ans>=a)
res++;
}
}
cout<<res;
getchar();getchar();
return 0;
}
6.Acwing 1219 移动距离
X星球居民小区的楼房全是一样的,并且按矩阵样式排列。
其楼房的编号为 1,2,3…1,2,3…
当排满一行时,从下一行相邻的楼往反方向排号。
比如:当小区排号宽度为 6 时,开始情形如下:
1 2 3 4 5 6
12 11 10 9 8 7
13 14 15 …
我们的问题是:已知了两个楼号 mm 和 nn,需要求出它们之间的最短移动距离(不能斜线方向移动)。
输入格式
输入共一行,包含三个整数 w,m,n,w 为排号宽度,m,n为待计算的楼号。
输出格式
输出一个整数,表示 m,n两楼间最短移动距离。
数据范围
1≤w,m,n≤10000
输入样例:
6 8 2
输出样例:
4
//本题为一个数值蛇形排列的矩阵,求两点的曼哈顿距离
#include
#include
#include
#include
using namespace std;
int w,m,n;
int main()
{
cin>>w>>m>>n;
m--;n--; //所有数减一便于操作
int x1,x2,y1,y2;
x1=m/w;x2=n/w;
y1=m%w;y2=n%w;
//偶数行反转
if(x1%2) y1=w-1-y1;
if(x2%2) y2=w-1-y2;
cout<<abs(x1-x2)+abs(y1-y2);
getchar();getchar();
return 0;
}
7.Acwing 1229 日期问题
小明正在整理一批历史文献。这些历史文献中出现了很多日期。
小明知道这些日期都在1960年1月1日至2059年12月31日。
令小明头疼的是,这些日期采用的格式非常不统一,有采用年/月/日的,有采用月/日/年的,还有采用日/月/年的。
更加麻烦的是,年份也都省略了前两位,使得文献上的一个日期,存在很多可能的日期与其对应。
比如02/03/04,可能是2002年03月04日、2004年02月03日或2004年03月02日。
给出一个文献上的日期,你能帮助小明判断有哪些可能的日期对其对应吗?
输入格式
一个日期,格式是”AA/BB/CC”。
即每个’/’隔开的部分由两个 0-9 之间的数字(不一定相同)组成。
输出格式
输出若干个不相同的日期,每个日期一行,格式是”yyyy-MM-dd”。
多个日期按从早到晚排列。
数据范围
0≤A,B,C≤9
输入样例:
02/03/04
输出样例:
2002-03-04
2004-02-03
2004-03-02
#include
#include
#include
#include
using namespace std;
//日期问题套路
int days[13] = {
0, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};
bool check(int year, int month, int day) //判断日期是否符合规定
{
if (month == 0 || month > 12) return false;
if (day == 0) return false;
//对2月特殊处理
if (month != 2)
{
if (day > days[month]) return false;
}
else
{
int leap = year % 100 && year % 4 == 0 || year % 400 == 0; //若为闰年则leap=1
if (day > 28 + leap) return false;
}
return true;
}
int main()
{
int a, b, c;
scanf("%d/%d/%d", &a, &b, &c);
for (int date = 19600101; date <= 20591231; date ++ ) //直接在所给范围内枚举所有情况
{
int year = date / 10000;
int month = date % 10000 / 100;
int day = date % 100;
if (check(year, month, day)) //判断当前枚举是否符合年月日的规则
{
if (year % 100 == a && month == b && day == c || // 年/月/日
month == a && day == b && year % 100 == c || // 月/日/年
day == a && month == b &&year % 100 == c) // 日/月/年
printf("%d-%02d-%02d\n", year, month, day); //%02d可以实现自动补零效果
}
}
getchar();getchar();
return 0;
}
8.getline用法
getline()的原型:
头文件:#include
istream& getline ( istream &is , string &str , char delim );
其中,istream &is 表示一个输入流,譬如cin;
string&str表示把从输入流读入的字符串存放在这个字符串中(可以自己随便命名,str什么的都可以);
char delim表示遇到这个字符停止读入,在不设置的情况下系统默认该字符为’\n’,也就是回车换行符(遇到回车停止读入)。
例子:
int main()
{
string line:
while(getline(cin,line))
cout<
}
C++ string的back与front
string a=“abcd”;
1.获取字符串最后一个字符
auto b=a.back(); //结果为 b=‘d’;
2.修改字符串最后一个字符
a.back()=’!’; //结果为 a=“abc!”;
3.获取字符串第一个字符
auto b=a.front(); //结果为 b=‘a’;
4.修改字符串第一个字符
a.front()=’!’; //结果为 a="!bcd";
acwing 1231 航班时间
小 h 前往美国参加了蓝桥杯国际赛。
小 h 的女朋友发现小 h 上午十点出发,上午十二点到达美国,于是感叹到“现在飞机飞得真快,两小时就能到美国了”。
小 h 对超音速飞行感到十分恐惧。
仔细观察后发现飞机的起降时间都是当地时间。
由于北京和美国东部有 12 小时时差,故飞机总共需要 14 小时的飞行时间。
不久后小 h 的女朋友去中东交换。
小 h 并不知道中东与北京的时差。
但是小 h 得到了女朋友来回航班的起降时间。
小 h 想知道女朋友的航班飞行时间是多少。
对于一个可能跨时区的航班,给定来回程的起降时间。
假设飞机来回飞行时间相同,求飞机的飞行时间。
输入格式
一个输入包含多组数据。
输入第一行为一个正整数 T,表示输入数据组数。
每组数据包含两行,第一行为去程的起降时间,第二行为回程的起降时间。
起降时间的格式如下:
#include
#include
#include
#include
using namespace std;
int get_second(int h,int m,int s)
{
return h*3600+m*60+s;
}
int get_time()
{
string line;
getline(cin,line);
if(line.back()!=')') line+="(+0)"; //统一格式
int h1,m1,s1,h2,m2,s2,d;
sscanf(line.c_str(),"%d:%d:%d %d:%d:%d (+%d)",&h1,&m1,&s1,&h2,&m2,&s2,&d); //sscanf()会将参数str的字符串根据参数format字符串来转换并格式化数据
//c_str()函数返回一个指向正规c字符串的指针,内容和string类的本身对象是一样的,通过string类的c_str()函数能够把string对象转换成c中的字符串的样式;
return get_second(h2,m2,s2)-get_second(h1,m1,s1)+d*24*3600;
}
int main()
{
int n;
cin>>n;
string line;
getline(cin,line); //读掉第一行的回车
while(n--)
{
int time=(get_time()+get_time())/2; //转化为秒计算
int hour=time/3600,minute=time%3600/60,second=time%60;
printf("%02d:%02d:%02d\n",hour,minute,second);
}
getchar();getchar();
return 0;
}
9.Acwing 1241. 外卖店优先级
“饱了么”外卖系统中维护着 N 家外卖店,编号 1∼N。
每家外卖店都有一个优先级,初始时 (0 时刻) 优先级都为 0。
每经过 1个时间单位,如果外卖店没有订单,则优先级会减少 1,最低减到 0;而如果外卖店有订单,则优先级不减反加,每有一单优先级加 2。
如果某家外卖店某时刻优先级大于 5,则会被系统加入优先缓存中;如果优先级小于等于 33,则会被清除出优先缓存。
给定 T时刻以内的 M 条订单信息,请你计算 T 时刻时有多少外卖店在优先缓存中。
输入格式
第一行包含 3 个整数 N,M,TN,M,T。
以下 M 行每行包含两个整数 ts 和 id,表示 ts 时刻编号 id 的外卖店收到一个订单。
输出格式
输出一个整数代表答案。
数据范围
1≤N,M,T≤105
1≤ts≤T
1≤id≤N
输入样例:
2 6 6
1 1
5 2
3 1
6 2
2 1
6 2
输出样例:
1
样例解释
6 时刻时,1 号店优先级降到 3,被移除出优先缓存;2 号店优先级升到 6,加入优先缓存。
所以是有 1 家店 (2 号) 在优先缓存中。
#include
#include
#include
#include
using namespace std;
const int N=100010;
int n,m,T,cnt; //last[i]表示第i个店铺上一次有订单的时刻
int score[N],last[N]; //score[i]表示第u个店铺当前的优先级
bool st[N]; //st[i]表示第i个店铺当前是否处于优先缓存之中
pair<int,int> order[N]; //pair可以进行双关键字排序,若第一个相同,则根据第二个排序
int main()
{
scanf("%d%d%d",&n,&m,&T);
for(int i=0;i<m;i++) scanf("%d%d",&order[i].first,&order[i].second);
sort(order,order+m);
for(int i=0;i<m;) //对同一店同一时刻的订单一起处理,即一批批处理
{
//分批
int j=i;
while(j<m&&order[j]==order[i]) j++;
int t=order[i].first,id=order[i].second;
cnt=j-i; //cnt计数
i=j; //更新i
//
int tspan=t-last[id]-1;
score[id]=score[id]-tspan; //没有订单的时候score减小
if(score[id]<0) score[id]=0;
if(score[id]<=3) st[id]=false;
score[id]+=2*cnt;
if(score[id]>5) st[id]=true;
last[id]=t; //更新last[id]
}
//对每一个餐馆的最后一次订单一直到结束的这段时间,score需要减小
for (int i=1;i<=n;i++)
{
if (last[i] < T)
{
score[i]-=T-last[i];
if (score[i] <= 3) st[i] = 0;
}
}
int ans = 0;
for (int i = 1; i <= n; i++) ans += st[i];
cout << ans << endl;
getchar();getchar();
return 0;
}